#include <stdio.h>

struct rthunk {
	void* env;
	double (*entry)(void*);
};
#define rthunk_run(th) ((th).entry((th).env))

struct aframe {
	double aret;
	int k;
	struct rthunk x1, x2, x3, x4, x5;
};

struct bframe {
	double bret;
	struct aframe *schain;
};

void arun(struct aframe* this);
void brun(struct bframe* this);

double bproc(void* env)
{
	struct bframe* this = env;

	brun(this);
	return this->bret;
}

double constproc(void* ic)
{
	return *(double*)ic;
}

void brun(struct bframe* this)
{
	struct aframe arec;
	struct bframe brec;
	this->schain->k--;
	brec.schain = this->schain;
	arec.k = this->schain->k;
	arec.x1.env = &brec;
	arec.x1.entry = bproc;
	arec.x2 = this->schain->x1;
	arec.x3 = this->schain->x2;
	arec.x4 = this->schain->x3;
	arec.x5 = this->schain->x4;
	arun(&arec);
	this->bret = this->schain->aret = arec.aret;
}

void arun(struct aframe* this)
{
	if (this->k <= 0)
		this->aret = rthunk_run(this->x4) + rthunk_run(this->x5);
	else {
		struct bframe bcall;
		bcall.schain = this;
		brun(&bcall);
	}
}

double cpool[] = { 1, -1, -1, 1, 0 };

int main(int argc, char** argv)
{
	struct aframe atop;
      
	atop.k = 10;
	atop.x1.env = &cpool[0];
	atop.x1.entry = constproc;
	atop.x2.env = &cpool[1];
	atop.x2.entry = constproc;
	atop.x3.env = &cpool[2];
	atop.x3.entry = constproc;
	atop.x4.env = &cpool[3];
	atop.x4.entry = constproc;
	atop.x5.env = &cpool[4];
	atop.x5.entry = constproc;
	arun(&atop);
	printf("%g\n", atop.aret);
	return 0;
}
